Status: Reopened Start date: 2008-08-04

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: Candidate for next major release   

Resolution:    

Description

Sometimes, I submit an issue, but down the road am no longer responsible for tracking it.  I'd like to be able to change the owner of

the issue so that I no longer receive emails on the issue and it is clearer who is responsible for tracking issue.  The new owner can

already make themselves watcher to get the emails but this change would eliminate that step.

Related issues:

Related to Redmine - Defect #6373: Can't Set author_id When Creating New Issu... Closed 2010-09-12

Related to Redmine - Feature #4805: Replace original "Added by" in Issue Copy... New 2010-02-11

Related to Redmine - Feature #7896: submit issue on behalf of other user New 2011-03-16

Related to Redmine - Feature #31106: Issue import should allow for importing ... New

Related to Redmine - Feature #11294: Option to choose the Issues owner on cop... New

Related to Redmine - Feature #12022: Change/Update author when an issue is re... Closed

Related to Redmine - Feature #9812: set or change author of a issue (via rest... New

Has duplicate Redmine - Feature #2035: Issue reporter should be editable Reopened 2008-10-15

Has duplicate Redmine - Feature #3642: Make author field modifiable Closed 2009-07-20

Has duplicate Redmine - Feature #3799: Change the author of an issue Closed 2009-08-31

Has duplicate Redmine - Feature #9701: Separate issue author and reporter Closed

Has duplicate Redmine - Feature #14465: Change author in redmine Closed

Has duplicate Redmine - Feature #23460: Changing the owner of an issue Closed

Associated revisions

Revision 21958 - 2022-11-16 10:24 - Go MAEDA

Add the ability to change the author of an issue (#1739).

Patch by Vladimir Kovacik, Jiri Stepanek, Aighan Pacobilch, Olivier Houdas, Takenori TAKAKI, and Mizuki ISHIKAWA.

Revision 21959 - 2022-11-16 10:44 - Go MAEDA

Update locales (#1739).

Revision 21960 - 2022-11-18 09:17 - Go MAEDA

Reverts r21958 and r21959 (#1739).

History

#1 - 2009-01-22 12:50 - Vincent de Lau

A related use case is one where somebody creates an issue for somebody else. For instance when somebody mails me an issue, I don't want to reply

'create a ticket' but want to be able to add it myself and make him or her the issue owner.

#2 - 2009-01-22 13:39 - Jean-Baptiste Barth

Vincent de Lau wrote:

A related use case is one where somebody creates an issue for somebody else. For instance when somebody mails me an issue, I don't want to

reply 'create a ticket' but want to be able to add it myself and make him or her the issue owner.

 I don't really understand the point. You have a field called "Assigned to" which is perfect for this purpose no ? And if you don't want to receive mail for

a specific issue why don't you click on "Unwatch" action ? I'm wondering if I missed something here...
#3 - 2009-01-22 16:17 - Jack Christensen

The case Vincent was making is the same point I made in #2035. If someone calls me with a support request I want to make a ticket with the caller as

the author, not me. I only entered it.

#4 - 2009-02-03 11:48 - Vincent de Lau

That was exactly my point and #2035 describes the problem even better.

#5 - 2009-07-20 22:10 - Paul Rivier

Indeed I don't understand why author and assignee auto-watching does not use the global watching mecanism. It would be much simpler to get

automatically added to the list of watchers when you open an issue or when your are assigned to it, so that you can latter resign from watching it

using the same simple mecanism. Can someone explain the current state of things please ?

#6 - 2009-09-02 07:14 - Anonymous

So what ? Is something planned to be able to modify the auther/recorder of an issue ?

Tx

#7 - 2009-09-03 11:14 - Ewan Makepeace

+1 on both issues - would like to be able to put issues under the correct persons name (as the author) because he/she is typically the one who is

asked to confirm that the problem is resolved.

#8 - 2009-12-26 20:03 - Henrik Steensland

+1

Is any work being done on this issue? Maybe as a plugin?

#9 - 2010-05-15 17:15 - Tharuka Pathirana

+1 I too think this is important and hope this will be added to the 1.0 Release.

#10 - 2010-06-23 09:09 - Vladimir Kovacik

- File redmine_changeable_author_v1.0.patch added

I have made a patch which probably does what you guys are referencing in this issue. It allows to change the author of an issue. This is possible only

when an user has permission "Edit author" (added by patch).

Field Author was renamed to Responsible which in case of our company better shows that the person is responsible for tracking the issue. Patch is

applicable to Redmine 0.9.2.stable.27112

#11 - 2010-06-23 12:29 - Pedro Gutierrez

+1

It happens to me all the time. I create issues on behalf of other people and then have to suffer all the notifications if not want to echo the project

completely off

#12 - 2010-07-04 00:04 - David Bennett

Vladimir Kovacik wrote:

I have made a patch which probably does what you guys are referencing in this issue. It allows to change the author of an issue. This is possible

only when an user has permission "Edit author" (added by patch).

Field Author was renamed to Responsible which in case of our company better shows that the person is responsible for tracking the issue. Patch

is applicable to Redmine 0.9.2.stable.27112

 Great Patch! I was just about to do this myself.

Works fine in 0.9.4.stable also :)

PS: I changed "Responsible" to "Reported By" as my clients didn't like the idea of being responsible... :P

#13 - 2010-08-09 11:34 - Tharuka Pathirana

map.permission :edit_issue_author, {}

2024-03-13 2/17

https://www.redmine.org/issues/2035
https://www.redmine.org/issues/2035


 in lib/redmine.rb.

Doesn't this need :require => :loggedin or something like that?

And I also think "Author" is better than "Responsible" because the Assignee is actually responsible for doing the task ;-)

Please include this (or #2035) in the next major release.

#14 - 2010-08-09 12:25 - Jean-Baptiste Barth

I don't think there's a consensus here (at least I disagree). Maybe there could be plugin facilities, or enhanced custom fields to handle use-cases you

report. But I'm still convinced that we should not provide the ability to change the author.

The author is the person who filled the ticket, it's like that, it's just the reality. If you need the author to be the guy himself, give him access to your

Redmine. If he's just "the target" or "the final client" or whatever, build a custom field for that, or even a plugin if you need a custom source or dynamic

things. You can even not display author anywhere if it doesn't matter to you, but in 99% of the cases I can think of, it just doesn't make any sense to

change the original author of an issue.

The next step would be to allow changing the author of each comment on a ticket, which seems absurd to me. It's the same problem. "Bob left a

comment. Hm, I don't like that. OK, let's say Alice left that comment. Done. Cool."

#15 - 2010-08-09 12:39 - Vincent de Lau

There are two roles to keep apart here, the author and the reporter. I agree that the author shouldn't be changeable, but the reporter role is different.

I'd be even happy if I can only select this one on creation time, but there are enough use cases where you'd want a different reporter then the author.

Walk-ins, phone and email submitted issues are among the real world examples that lead to this request and #2035. In an ideal world, all reporters

would use Redmine directly, but the world is not ideal...

Also, a comment is something completely different than an issue. An issue changes over time (state, assignee etc.) while a comment is something

you add to an issue while time progresses.

#16 - 2010-08-09 13:06 - Jean-Baptiste Barth

Agreed about the comments. About the author/reporter difference, I understand. I wonder if it could be integrated easily (keeping the two roles).

#17 - 2010-08-09 15:10 - Nick Peelman

I'll add a +1 here.  Definitely needs its own permission in order to change it, but Vincent and the others, author != reporter in all cases.

#18 - 2010-08-09 15:33 - Tharuka Pathirana

I agree that author != reporter

Still, this issue is also about notifications. If I have to submit a ticket on behalf of someone else (due to walk-in, phone or mail) but the original reporter

is supposed to oversee the progress of the issue and I'm not really involved in it anymore, then I don't want to get notification mails about changes.

About the comments: I don't see a lot of value in being able to change the comment author. I someone sends me a mail with a comment about a

certain issue, I add a comment to the issue quoting that person. That's good enough.

#19 - 2010-08-18 07:41 - Burt Culver

Paul Rivier wrote:

Indeed I don't understand why author and assignee auto-watching does not use the global watching mecanism. It would be much simpler to get

automatically added to the list of watchers when you open an issue or when your are assigned to it, so that you can latter resign from watching it

using the same simple mecanism. Can someone explain the current state of things please ?

 This seems like the middle path - add the author as a watcher and allow him/her to unwatch. If he has permissions then he can add the walk in

person as watcher.

#20 - 2010-09-08 15:10 - Adam Skubiszewski

+1 for this feature!

I think changing autor or setting him during creation of an issue is very important, it is a common use case when we have phone calls with issues and

we want to put them into redmine immediately. Sometimes users, even if they have account, they are afraid of using task management systems, so

issues must be physically entered by developers or help desk.

#21 - 2010-10-15 10:39 - Alois Vopicka

Hello.

I've used the patch from Vladimir, the field is editable, but nothing really happens after submitting. The permissions are correctly assigned.

Using version 1.0.1
#22 - 2010-11-15 11:36 - Anonymous

I am always looking for this feature. I have upgraded to Redmine 1.0.3 last week.

tx

#23 - 2010-11-24 15:40 - James Rowe

+1

#24 - 2010-12-08 10:51 - Jiri Stepanek

- File redmine_changeable_author_v1.0.4.patch added

Hi,

after experiencing the same behavior like Alois, I'm uploading an updated version of the patch above. Works for me, Redmine version 1.0.4.

#25 - 2010-12-16 15:31 - Adam Tsiopani

+1 very useful!!!

#26 - 2011-01-02 13:53 - Alex Sherman

+1 - Very usefull

A small bug: if changing the author during new issue creation - it is not saved. I have to edit the issue afterwards to change the author. (Redmine

1.0.5)

#27 - 2011-01-19 17:54 - Tharuka Pathirana

Version 1.2 please?

#28 - 2011-01-19 20:25 - Anonymous

When an employee, that has submitted some issues, left the company, i need to change the author of the issues by the new employe. For instance, i

did it by hand within the database...

#29 - 2011-02-03 15:53 - Anonymous

I've build an Plugin, that will change the author in redmine 1.1.x, thx for review!

[[http://www.redmine.org/plugins/redmine_changeauthor]]

#30 - 2011-02-07 19:15 - Chad Hauff

+1

I manage a group of developers and help Project Managers use Redmine. I frequently create issues for my team, but I don't want to get updates on

every single issue just because I created the issue. I would like to set the PM as the author so she and the assigned programmer get the updates. I

currently have 150+ open issues I authored, but I only want/need to get updates on about 20 of them.

My only work-around is to send an email to the PM and ask her to create a new issue by copy-pasting my email. Very inefficient.

Thanks.

#31 - 2011-05-23 11:58 - Maik Lindner

In app/views/issues/_attributes.rhtml we use "project.users" not "issue.assignable_users" because authors are not always assignable users.

#32 - 2011-05-27 16:25 - Etienne Massip

- Target version set to Unplanned backlogs

#33 - 2011-05-31 11:05 - Radek Karban

+1

#34 - 2011-06-21 15:36 - Olivier Gérardin

Definitely agree that the distinction between author and reporter is a necessary one and should be in the trunk.

-The author is the one who entered the issue, he's responsible for entering it correctly. This can't be changed since it's just an audit information.

-The reporter is the one who is the originator of the issue, he is the "owner" of the issue and is responsible for validating any fix. This one may be

different from the author (because the author may have been entering the issue on behalf of someone else) and may also be updated (because the

owner of an issue may change for a number of reasons during the lifetime of the issue)

#35 - 2011-08-14 13:44 - Terence Mill
+1

#36 - 2011-08-24 01:27 - Yehuda Katz

I was looking for info on how to change the author for a phone-entered ticket.

I would love to see a separate author and reporter.

The author is just so that we know who entered it and the reporter is the one who actually experienced the issue.

Another was to phrase this is "__author__ on behalf of reporter"

#37 - 2011-12-15 14:45 - Terence Mill

related to #7487

#38 - 2011-12-15 14:51 - Terence Mill

Yes, there should be an destinction between who just created the ticket and who reported it. In fact in support center case with telephone reporting,

never the reporter will create the ticket, but the author will know him and could manually set the reporter attribut. In case the author shall be a web

service (e.g. a via a web form which will creat issues inperonisating some reporter, whoh can't/ or don't want access redmine gui directly, this is very

useful.

Yehuda Katz wrote:

I was looking for info on how to change the author for a phone-entered ticket.

I would love to see a separate author and reporter.

The author is just so that we know who entered it and the reporter is the one who actually experienced the issue.

Another was to phrase this is "__author__ on behalf of reporter"

#39 - 2011-12-23 11:07 - Michael Steiner

+1

#40 - 2012-01-16 08:09 - Chrysovalanto Kousetti

+1

#41 - 2012-02-03 03:00 - thom rogers

SPAM SQUASHING

#42 - 2012-02-08 22:59 - Gary Ritchie

+1

#43 - 2012-03-01 09:13 - Victor Fokin

+1

#44 - 2012-03-15 08:46 - Leos Prikryl

+1

#45 - 2012-03-27 22:49 - Brian Heasley

+1

#46 - 2012-03-28 05:16 - avellinodesm John

- Assignee set to Mischa The Evil

-

#47 - 2012-03-28 05:19 - kirkkent John

-

#48 - 2012-03-28 17:03 - Etienne Massip

- Assignee deleted (Mischa The Evil)

#49 - 2012-04-08 12:00 - Radek Karban

+1

2024-03-13 5/17

https://www.redmine.org/issues/7487


#50 - 2012-05-16 17:49 - Francisco Garcia

+1

#51 - 2012-05-17 03:16 - Anonymous

+1

#52 - 2012-06-07 12:48 - Rick Mason

+1

I'm looking to enable the scenario in #6373 as well as allowing users to report an issue on behalf of someone else in the UI.

#53 - 2012-06-13 16:53 - Daniele Palumbo

+1.

Did anyone made the patch for 1.4?

#54 - 2012-06-22 17:35 - Anonymous

+1

Should be restricted to Managers and Developers

or

separate fields for creator/reporter of issue is good too

This would be useful for us, because I want reporters to get email updates (but are not regular users of redmine).

#55 - 2012-06-26 12:31 - Joerg Oswald

+1

#56 - 2012-06-26 18:28 - Hugo Zambotti

+1

#57 - 2012-06-27 05:46 - Scott Owen

+1

I am in favor of the "Change Author" functionality.

The key here is email traffic and who gets the notifications. I like to get emails for things I am the owner of and do not want that to change. However,

when I create an issue on someone else's behalf, I do not want to get emails on that issue as if I was the owner. If there are other reasons of concern

here (which are indicated in comments above), changing owner may not necessarily be required functionality--simply specifying the owner/reporter of

an issue at creation time would be enough. That said, I am more in favor of the "Change Author"

#58 - 2012-07-17 15:01 - Anatol Bollinger

+1

no matter how, there should be a way to prevent authors getting email notifications of issues there not concerned with (any more).

#59 - 2012-08-02 15:57 - Bruno Passos

+1

#60 - 2012-08-13 13:50 - Viktor Kuzmin

+1

#61 - 2012-08-23 13:34 - Christoph Keimel

+1

#62 - 2012-09-27 08:23 - Alexander Molchanov

+1

#63 - 2012-09-29 04:20 - ysbranddoug andeson

- Assignee set to Jean-Baptiste Barth

#109 - 2013-01-12 23:36 - Daniel Felix

+1
#110 - 2013-02-26 19:30 - Pavel Lautsevich

+1 Very very need it!

#111 - 2013-03-08 16:50 - Anonymous

+1

#112 - 2013-04-06 10:36 - Jean-Baptiste Barth

- Assignee deleted (Jean-Baptiste Barth)

Didn't see someone assigned the issue to me. Please don't do that, it's the best way to completely lose a ticket. I see there are a few valid use cases

but I still think it should be implemented as a plugin or made optionnal if integrated in core. Btw, it seems nobody has the time/energy/money to work

on this seriously for the moment...

#113 - 2013-06-19 18:50 - not available

This is a very basic and very needed feature - number of duplicated requests does confirm that. It's almost 5 years from the initial request. I do not

understand.

Is implementing a single dropdown/box/whatever for the current owner/author to transfer the issue ownership such a great pain?

What is the holdup?

#114 - 2013-06-20 08:50 - pasquale [:dedalus]

Burt Culver wrote:

I'd like to be able to change the owner of the issue so that I no longer receive emails on the issue

 The very question is show above!

I think that this bug can be closed as dupe of bug #11405.

My explanation: add ability to change bug opener\owner isn't a good choice because the BTS should be track the hystory of a bug (then also who

open it).

But also if I have open the bug, for some reason, it is legitimate not want to receive more mail alert after a day.

The solution for this question is to provide the same behavior of bugzilla as reported in bug #11405: when user open\edit a bug can flag\unflag an

option that sound as "add me as watcher". In bugzilla when user open\edit a bug this flag is per default true as show in bug #11405, but user can

unflag it if want.

#115 - 2013-06-20 18:19 - Pavel Lautsevich

No pasquale [:dedalus]! Author tasks should be able to transfer it to another user (the author may leave the project, resign, die, finally).

This is a very high demand functionality!

#116 - 2013-06-21 08:49 - pasquale [:dedalus]

Pavel Lautsevich wrote:

No pasquale [:dedalus]! Author tasks should be able to transfer it to another user (the author may leave the project, resign, die, finally).

 Ciao Pavel.

I don't agree: author of issue isn't a special user. If author don't want track anymore its created issue, as in request #11405, he can unflag "watchs"

(as in mozilla bugzilla). We are inform about people that track bug from watchers list (see #11405) and about the user that manage the issue via the

assignee.

But this is only my 2 cents (based on bugzilla, jira, etc  approach)

#117 - 2013-06-21 11:23 - Pavel Lautsevich

pasquale [:dedalus], just exactly in Jira you can change the author! I don't agree with and this functionality is in demand for me.

#118 - 2013-07-09 15:34 - Eric Maziade

Our use case for this : we use redmine for project tracking.

We have a "template" project which an administrator copies for a project manager when a project starts.

The administrator (the one making the copy) automatically becomes the owner of all the tasks in the project - even if he's not otherwise involved.

We'd love to be able to specify the owner when making a copy... or allowing a manager to make copies without having to give them full-out

administrative powers.
We'll "solve" this issue by creating a dummy admin user to create copies and send the emails in a black hole, but being able to change the owner

would help.

Or at the very least, allow the admin to have a bit more control over the email he receives.  As far as I know, he has no option to make himself

"non-involved" in these issues and stop receiving emails.

#119 - 2013-07-19 19:48 - Kris Lou

This plugin works for 2.3.1:   https://github.com/thorin/redmine_changeauthor

My only complaint is that it doesn't generate a trackable event (journal?), so there is no record of the transaction nor email notification.  It simply

changes the author.

#120 - 2013-07-22 08:54 - Toshi MARUYAMA

- Related to Feature #14465: Change author in redmine added

#121 - 2013-07-22 08:55 - Toshi MARUYAMA

- Related to deleted (Feature #14465: Change author in redmine)

#122 - 2013-07-22 08:56 - Toshi MARUYAMA

- Has duplicate Feature #14465: Change author in redmine added

#123 - 2013-07-31 20:01 - Eric Maziade

Kris Lou wrote:

This plugin works for 2.3.1:   https://github.com/thorin/redmine_changeauthor

My only complaint is that it doesn't generate a trackable event (journal?), so there is no record of the transaction nor email notification.  It simply

changes the author.

 Thanks for the link.  There is an option in the plugin settings to add an event to the journal.

(And +1 to add this feature to the roadmap :) )

#124 - 2013-08-05 17:29 - Cédric BETHENCOURT

+1 for this feature

#125 - 2013-09-02 17:40 - Aighan Pacobilch

- File redmine_changeable_author_v2.1.6.patch added

Patch updated for Redmine 2.1.6

#126 - 2014-01-30 18:56 - Frederik Jung

This plugin works for 2.4.2: https://github.com/mcl-de/redmine_change_issue_author

it's a port of the patch ;)

and the behavior should be the same

#127 - 2014-01-31 05:02 - Anonymous

+2

#128 - 2014-02-05 09:27 - Michaël Luitaud

Eric Maziade wrote:

Kris Lou wrote:

This plugin works for 2.3.1:   https://github.com/thorin/redmine_changeauthor

My only complaint is that it doesn't generate a trackable event (journal?), so there is no record of the transaction nor email notification.  It

simply changes the author.

 Thanks for the link.  There is an option in the plugin settings to add an event to the journal.

(And +1 to add this feature to the roadmap :) )
 Hello,

The plugin does not works with my 2.3.1. Indeed, when I want to configure it or want to open a issue, I get a 404 error.

I guess it is linked with #7430#11 but it's a bit creepy...

Is there a chance the redmine_cnahge_issue_autor works for the 2.3.1?

Thanks

#129 - 2014-02-05 10:07 - Frederik Jung

I had reset my redmine to 2.3.1 and tested the plugin.

but I got no error ...

could you please give me the error log -> redmine/log/production.log

did you run: bundle install ?

#130 - 2014-02-05 11:01 - Ferenc Balázs Farkas

- File redmineplugininstall.jpg added

Hey there!

My problem is with Mr. Jung's plugin is that after restarting apache2 Ruby on Rails cannot start. I have an otherwise perfectly working Redmine 2.4.1

Other info:

Redmine version                2.4.1.stable

Ruby version                   1.8.7-p352 (2011-06-30) [x86_64-linux]

Rails version                  3.2.16

Environment                    production

Database adapter               MySQL

Any ideas? Thank you in advance. (I also attached a screenshot of the error, and yeah I see that nokogiri is missing but if I go down that road a lot of

other stuff starts missing.)

#131 - 2014-02-05 11:35 - Frederik Jung

the error message says: you have to install nokogiri >= 1.5.5

try: gem install nokogiri

#132 - 2014-02-05 16:50 - Ferenc Balázs Farkas

Sooo, my problem is mainly off topic. (I created a puppet process to install a fully working redmine but it's degrading my ruby to 1.8.7 which is not

good for nokogiri etc.)

Thanks by the way!

#133 - 2014-02-06 14:51 - Michał Senderowski

Hello

I've installed plugin https://github.com/mcl-de/redmine_change_issue_author. I've found place where I can give permsion 'Edit issue author', but I still

can't find the place where can I change issue author.

Thanks for help.

#134 - 2014-02-06 15:54 - Frederik Jung

- File change issue owner.png added

at the issue?

look at the image.

#135 - 2014-02-07 10:29 - Michaël Luitaud

- File Capture.PNG added

Frederik Jung wrote:

I had reset my redmine to 2.3.1 and tested the plugin.

but I got no error ...
 could you please give me the error log -> redmine/log/production.log

 did you run: bundle install ?

 I was talking about the changeauthor plugin and not the change_issue_author one.

I have now installed (in fact I asked my IT administrator to do it, I have no access to the servor :-(( ) the change_issue_author plugin BUT I have the

same problem as Michał Senderowski. Cf. my image.

I don't think so but can it be linked to the language?

Michał Senderowski wrote:

Hello

I've installed plugin https://github.com/mcl-de/redmine_change_issue_author. I've found place where I can give permsion 'Edit issue author', but I

still can't find the place where can I change issue author.

Thanks for help.

#136 - 2014-02-07 10:43 - Frederik Jung

ok, sorry about that :p

could you please tell me more about your setup ... like redmine info?

which version of nokogiri is installed?

did you have a modified [/app/views/issues/_attributes.html.erb]

or does modify another plugin this file?

#137 - 2014-02-10 12:01 - Michał Senderowski

I haven't got field author.

My Redmine info:

Environment:

Redmine version                2.3.2.stable.12071

Ruby version                   1.8.7-p352 (2011-06-30) [x86_64-linux]

Rails version                  3.2.13

Environment                    production

Database adapter               Mysql2

Redmine plugins:

redmine_change_issue_author    0.0.1

redmine_ldap_sync              2.0.2.devel.g5c00b31622-dirty

I have nogiri in version 1.5.5.

I did not modify [/app/views/issues/_attributes.html.erb]. Should I modify it ?

#138 - 2014-02-11 21:35 - Arthur Fabre

- File changeauthor.JPG added

I'm also experiencing an issue on redmine 2.4.3.

The author field doesn't show up when updating the page, however there is a link called "Update author" - see the image below.

Following the link results in a 500 however, here's the stack trace:

Started GET "/changeauthor/index?issue_id=30" for 82.15.175.41 at 2014-02-11 20:19:18 +0000

Processing by ChangeauthorController#index as HTML

Parameters: {"issue_id"=>"30"}

Current user: arthur (id=4)

Completed 500 Internal Server Error in 16.4ms

NoMethodError (undefined method `project_id' for #<ActiveRecord::Relation:0x0000000719b9d0>):

activerecord (3.2.16) lib/active_record/relation/delegation.rb:45:in `method_missing'

plugins/redmine_changeauthor/app/controllers/changeauthor_controller.rb:7:in `index'

actionpack (3.2.16) lib/action_controller/metal/implicit_render.rb:4:in `send_action'

actionpack (3.2.16) lib/abstract_controller/base.rb:167:in `process_action'

actionpack (3.2.16) lib/action_controller/metal/rendering.rb:10:in `process_action'
actionpack (3.2.16) lib/abstract_controller/callbacks.rb:18:in `block in process_action'

activesupport (3.2.16) lib/active_support/callbacks.rb:469:in `_run__2813722203579391689__process_action__2722617602805932813__callbacks'

activesupport (3.2.16) lib/active_support/callbacks.rb:405:in `__run_callback'

activesupport (3.2.16) lib/active_support/callbacks.rb:385:in `_run_process_action_callbacks'

activesupport (3.2.16) lib/active_support/callbacks.rb:81:in `run_callbacks'

actionpack (3.2.16) lib/abstract_controller/callbacks.rb:17:in `process_action'

actionpack (3.2.16) lib/action_controller/metal/rescue.rb:29:in `process_action'

actionpack (3.2.16) lib/action_controller/metal/instrumentation.rb:30:in `block in process_action'

activesupport (3.2.16) lib/active_support/notifications.rb:123:in `block in instrument'

activesupport (3.2.16) lib/active_support/notifications/instrumenter.rb:20:in `instrument'

activesupport (3.2.16) lib/active_support/notifications.rb:123:in `instrument'

actionpack (3.2.16) lib/action_controller/metal/instrumentation.rb:29:in `process_action'

actionpack (3.2.16) lib/action_controller/metal/params_wrapper.rb:207:in `process_action'

activerecord (3.2.16) lib/active_record/railties/controller_runtime.rb:18:in `process_action'

actionpack (3.2.16) lib/abstract_controller/base.rb:121:in `process'

actionpack (3.2.16) lib/abstract_controller/rendering.rb:45:in `process'

actionpack (3.2.16) lib/action_controller/metal.rb:203:in `dispatch'

actionpack (3.2.16) lib/action_controller/metal/rack_delegation.rb:14:in `dispatch'

actionpack (3.2.16) lib/action_controller/metal.rb:246:in `block in action'

actionpack (3.2.16) lib/action_dispatch/routing/route_set.rb:73:in `call'

actionpack (3.2.16) lib/action_dispatch/routing/route_set.rb:73:in `dispatch'

actionpack (3.2.16) lib/action_dispatch/routing/route_set.rb:36:in `call'

journey (1.0.4) lib/journey/router.rb:68:in `block in call'

journey (1.0.4) lib/journey/router.rb:56:in `each'

journey (1.0.4) lib/journey/router.rb:56:in `call'

actionpack (3.2.16) lib/action_dispatch/routing/route_set.rb:608:in `call'

rack-openid (1.4.2) lib/rack/openid.rb:98:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/best_standards_support.rb:17:in `call'

rack (1.4.5) lib/rack/etag.rb:23:in `call'

rack (1.4.5) lib/rack/conditionalget.rb:25:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/head.rb:14:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/params_parser.rb:21:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/flash.rb:242:in `call'

rack (1.4.5) lib/rack/session/abstract/id.rb:210:in `context'

rack (1.4.5) lib/rack/session/abstract/id.rb:205:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/cookies.rb:341:in `call'

activerecord (3.2.16) lib/active_record/query_cache.rb:64:in `call'

activerecord (3.2.16) lib/active_record/connection_adapters/abstract/connection_pool.rb:479:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/callbacks.rb:28:in `block in call'

activesupport (3.2.16) lib/active_support/callbacks.rb:405:in `_run__173549760009239244__call__2787787754557319768__callbacks'

activesupport (3.2.16) lib/active_support/callbacks.rb:405:in `__run_callback'

activesupport (3.2.16) lib/active_support/callbacks.rb:385:in `_run_call_callbacks'

activesupport (3.2.16) lib/active_support/callbacks.rb:81:in `run_callbacks'

actionpack (3.2.16) lib/action_dispatch/middleware/callbacks.rb:27:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/remote_ip.rb:31:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/debug_exceptions.rb:16:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/show_exceptions.rb:56:in `call'

railties (3.2.16) lib/rails/rack/logger.rb:32:in `call_app'

railties (3.2.16) lib/rails/rack/logger.rb:18:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/request_id.rb:22:in `call'

rack (1.4.5) lib/rack/methodoverride.rb:21:in `call'

rack (1.4.5) lib/rack/runtime.rb:17:in `call'

activesupport (3.2.16) lib/active_support/cache/strategy/local_cache.rb:72:in `call'

rack (1.4.5) lib/rack/lock.rb:15:in `call'

actionpack (3.2.16) lib/action_dispatch/middleware/static.rb:63:in `call'

rack-cache (1.2) lib/rack/cache/context.rb:136:in `forward'

rack-cache (1.2) lib/rack/cache/context.rb:245:in `fetch'

rack-cache (1.2) lib/rack/cache/context.rb:185:in `lookup'

rack-cache (1.2) lib/rack/cache/context.rb:66:in `call!'

rack-cache (1.2) lib/rack/cache/context.rb:51:in `call'

railties (3.2.16) lib/rails/engine.rb:484:in `call'

railties (3.2.16) lib/rails/application.rb:231:in `call'

railties (3.2.16) lib/rails/railtie/configurable.rb:30:in `method_missing'

passenger (4.0.37) lib/phusion_passenger/rack/thread_handler_extension.rb:77:in `process_request'

passenger (4.0.37) lib/phusion_passenger/request_handler/thread_handler.rb:142:in `accept_and_process_next_request'

passenger (4.0.37) lib/phusion_passenger/request_handler/thread_handler.rb:110:in `main_loop'

passenger (4.0.37) lib/phusion_passenger/request_handler.rb:448:in `block (3 levels) in start_threads'

#139 - 2014-04-07 13:52 - David Robinson

Making the changes below to config/routes.rb I was able to have the changeauthor plugin work without 404 errors on redmine 2.4.4

I have submitted a pull request for the changes.

config/routes.rb ->

2024-03-13 11/17

https://github.com/thorin/redmine_changeauthor


RedmineApp::Application.routes.draw do

  get '/changeauthor/edit/:id' => 'changeauthor#edit', :as => 'edit_changeauthor'

  put '/changeauthor/update/:id' => 'changeauthor#update', :as => 'changeauthor'

end

#140 - 2014-08-18 05:17 - Quan VN

The change by David Robinson does not help in redmine 2.5.2, I still get 404 error

#141 - 2015-04-04 11:29 - Go MAEDA

- Related to Feature #4805: Replace original "Added by" in Issue Copy function added

#142 - 2015-04-09 17:44 - [ Desperados ]

Hi

it doesn't work with redmine 3

#143 - 2015-04-30 18:10 - Arnis Juraga

Right, problem with version 3.0.1

ActiveRecord::RecordNotFound (Couldn't find all Members with 'id': 

(all, {:include=>[:roles, :principal], :order=>"firstname", :conditions=>"users.type='User'"}) 

[WHERE `members`.`project_id` = ? AND (users.status=1)] (found 0 results, but was looking for 2)):

#144 - 2015-07-08 23:52 - Michael Martin

Please add patch to work with 3.0.1

#145 - 2015-07-09 00:19 - Deoren Moor

+1 for this feature. We use Redmine as a HelpDesk solution and with rotating staff would really benefit from this. I can see Author changes being

tracked much like Status changes are tracked now.

#146 - 2015-08-06 17:00 - Olivier Houdas

- File redmine_changeable_author_v2.1.7.patch added

Here is a patch for Redmine 3.1.0 (be careful, there are changes compared to 3.0.*), which works on our pre-production server.

I stripped the original patch of a change on showing "added time", and I added French translation for the new right.

We're using MS SQL 2012 as our DB system.

[edit: I should have named my patch _v3.1.0.patch...]

#147 - 2015-08-07 04:39 - Go MAEDA

Olivier Houdas wrote:

Here is a patch for Redmine 3.1.0 (be careful, there are changes compared to 3.0.*), which works on our pre-production server.

 The patch can be applied to the current trunk without any problems and works fine. Thanks.

#148 - 2015-12-17 13:20 - Arnis Juraga

Olivier Houdas wrote:

Here is a patch for Redmine 3.1.0 (be careful, there are changes compared to 3.0.*), which works on our pre-production server.

I stripped the original patch of a change on showing "added time", and I added French translation for the new right.

We're using MS SQL 2012 as our DB system.

[edit: I should have named my patch _v3.1.0.patch...]

 Nice!

Applied patch, it worked ok, with one reject, but file was modified.

/opt/redmine/redmine-ri-3.0.1/app/views/issues/show.html.erb.rej

--- app/views/issues/show.html.erb    Sun Jul 26 07:10:55 2015 +0000

+++ app/views/issues/show.html.erb    Thu Aug 06 16:55:23 2015 +0200
@@ -35,6 +35,7 @@

 <table class="attributes">

 <%= issue_fields_rows do |rows|

+  rows.left l(:field_author), @issue.author, :class => 'author'

   rows.left l(:field_status), @issue.status.name, :class => 'status'

   rows.left l(:field_priority), @issue.priority.name, :class => 'priority' 

#149 - 2016-01-27 18:52 - Olivier Houdas

Warning: With Redmine 3.2.0, issues with Anonymous author will be updated to the first user available when this patch is active and the issue is

updated with a user having the edit_issue_author right.

This is due to a change in Redmine filtering the user list on active users only: see #21477.

So the patch should be changed for Redmine 3.2.0 and above users to add the original author manually in views/issues/_attributes.html.erb, so that it

doesn't get changed accidentally if it became inactive between creating the issue and the latest edit:

<p><%= f.select :author_id, (@issue.assignable_users.collect {|m| [m.name, m.id]} << [@issue.author.name, @issue.author.id]), :include_blank =>

false, :required => true %></p>

[edited 2016-01-27 19:27] given the change done in #21477, it is actually safer to force having the original author in the list so as not to lose it

accidentally, rather than adding Anonymous.

#150 - 2016-07-29 02:16 - Go MAEDA

- Has duplicate Feature #23460: Changing the owner of an issue added

#151 - 2016-07-29 16:10 - JW Fuchs

+1

#152 - 2016-08-09 08:05 - Ismael Barros²

+1

#153 - 2016-08-13 08:58 - Klavs Klavsen

+1  - anyone have a patch for latest redmine that works? Just updated from 2.x - where I was using 

http://www.redmine.org/plugins/redmine_change_issue_author - but that stopped working with redmine 3.x :(

#154 - 2016-11-07 13:16 - Sebastian Paluch

over 150 comments, looks like something desired by many users, maybe could get a bit higher priority?

#155 - 2016-11-11 15:48 - Маргарита Радужная

+1

#156 - 2016-12-24 09:17 - Go MAEDA

- Related to Feature #7896: submit issue on behalf of other user added

#157 - 2017-01-04 11:11 - Rene H

Yes, please. Please add a feature where the author of the issue can be changed. Now it's just too much hassle to edit manually the issues-table and

change the author_id to the desired author..

Unfortunately i don't know python, so i can't fix the plugin ;_(

#158 - 2017-02-16 13:29 - Ladislav Nesnera

+1

#159 - 2017-02-16 14:17 - Andrey Lobanov (RedSoft)

Here's my fork and it's working with 3.x.

https://github.com/woblavobla/redmine_changeauthor

#160 - 2017-02-16 16:47 - Anonymous

I am currently using this plugin :

https://github.com/rgtk/redmine_editauthor

i am going to test the one from Andrey Lobanov and see how it works.

#161 - 2017-11-29 12:05 - Jess Nielsen
+1

#162 - 2018-07-27 08:32 - Bubi =

+1

#163 - 2018-11-18 21:26 - Yar n

+1

it should be added in core

#164 - 2019-06-04 07:50 - T H

+1

It's definitely the feature we are missing the most from redmine.  So I second the move to add it as core functionality.

#165 - 2019-09-06 11:43 - billy chou

+1

#166 - 2019-10-30 10:03 - Go MAEDA

- Related to Feature #31106: Issue import should allow for importing the author and creation date fields, too. added

#167 - 2020-01-10 14:03 - Stewart Ferguson

+1

Any plugins confirmed working for redmine 4.X?

#168 - 2020-01-10 14:18 - Valdir Stiebe Junior

We are using this plugin with 4.1.0 without any issues.

https://github.com/rgtk/redmine_editauthor.git

#169 - 2020-03-20 07:40 - T H

We are using this plugin with 4.1.0 without any issue

 Yes, we have that installed, too.  It works well with one feature lacking, though: We use Redmine as a tool where any employee of our company can

log an issue but only a small set of developers and testers are actually members of the project.  The plugin does not allow to set any author but

restricts the list to the project members (plus global admins, if I recall correctly).  The feature we are looking for should be able to set any registered

redmine user as the author.

#170 - 2021-01-15 17:49 - Jan K.

+1

#171 - 2021-01-20 17:12 - Kevin Palm

+1 for integrating this as core functionality

#172 - 2021-04-19 10:02 - Heiko Böhme

+1

#173 - 2021-06-07 05:45 - Go MAEDA

- Related to Feature #11294: Option to choose the Issues owner on copy project  added

#174 - 2021-06-10 03:38 - Go MAEDA

- Related to Feature #12022: Change/Update author when an issue is re-opened to the person who re-opens added

#175 - 2021-06-21 08:10 - Takenori TAKAKI

- File redmine_changeable_author_v4.2.1.patch added

I made a patch that works on v4.2.1.

Added some changes and tests to the previously posted patch.

#176 - 2021-12-24 02:09 - Go MAEDA
- Target version changed from Unplanned backlogs to Candidate for next major release

#177 - 2021-12-25 09:20 - Go MAEDA

- File redmine_changeable_author_r21324.patch added

Updated the patch for the latest trunk.

But the patch unexpectedly changes the author to "<< me >>" if the current author is Anonymous. This has already been pointed out in 

#1739#note-149.

#178 - 2022-01-25 02:43 - Mizuki ISHIKAWA

- File redmine_changeable_author_r21387.patch added

But the patch unexpectedly changes the author to "<< me >>" if the current author is Anonymous. This has already been pointed out in 

#1739#note-149.

 I have attached a patch that fixes this problem.

Also, if you specify a different user as Author when creating a issue, the Journal will be created in the same way as when updating. This is a function

to keep a record of the user who actually created the issue.

#179 - 2022-02-07 15:45 - Go MAEDA

- Target version changed from Candidate for next major release to 5.0.0

Setting the target version to 5.0.0.

#180 - 2022-02-15 10:32 - Bernhard Rohloff

I've tried the patch from #note-178 and as far as I can see it works as expected. It's a nice feature.

#181 - 2022-03-20 22:24 - Marius BĂLTEANU

- Target version changed from 5.0.0 to Candidate for next major release

#182 - 2022-09-05 03:53 - Go MAEDA

- File redmine_changeable_author_r21799.patch added

Updated the patch for the current trunk r21799.

#183 - 2022-09-29 08:59 - Johan Steur

Error when applying this patch on Bitnami Redmine stable 5.0.2. Am I doing something wrong here?

root@redmine:/opt/bitnami/redmine# patch -p0 < redmine_changeable_author_r21799.patch  can't find file to patch at input line 5 Perhaps you used

the wrong -p or --strip option? The text leading up to this was: -------------------------- |diff --git a/app/helpers/issues_helper.rb

b/app/helpers/issues_helper.rb |index de4ca4435..891b993be 100644 |--- a/app/helpers/issues_helper.rb |+++ b/app/helpers/issues_helper.rb

-------------------------- File to patch:

#184 - 2022-09-29 09:01 - Johan Steur

Error when applying this patch on Bitnami Redmine stable 5.0.2. Am I doing something wrong here?

root@redmine:/opt/bitnami/redmine# patch p0 < redmine_changeable_author_r21799.patch

can't find file to patch at input line 5

Perhaps you used the wrong -p or --strip option?

The text leading up to this was:

------------------------- |diff --git a/app/helpers/issues_helper.rb b/app/helpers/issues_helper.rb |index de4ca4435..891b993be 100644 |---

a/app/helpers/issues_helper.rb |+++ b/app/helpers/issues_helper.rb

--------------------------

File to patch:

#185 - 2022-10-12 06:47 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0
Setting the target version to 5.1.0.

#186 - 2022-11-16 10:24 - Go MAEDA

- Subject changed from Add ability to change issue owner to Add ability to change issue author

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thanks to everyone involved in the development of this feature.

Members who have "Change issue author" permission can change the author of an issue

Changes are recorded in the journal

#187 - 2022-11-16 15:20 - Holger Just

- Status changed from Closed to Reopened

- Resolution deleted (Fixed)

Unfortunately, there does not appear to be any actual validation of the passed author_id on the backend. This would currently allow someone who

has the permission to set the author_id of an issue to set ANY user id (which has to exist, but only by luck). This would then possibly allow this user to

enumerate all users in the system and at least find their respective display names.

As a remedy, we should probably validate the allowed author_id against the list currently built in IssuesHelper#author_options_for_select. This list

should then probably be moved to a method on the Issue model, named e.g. Issue#allowed_authors. The helper method should then be adapted to

use Issue#allowed_authors.

This could look like this:

class Issue

  #...

  def validate_issue

    # ...

    if project && author_id_changed?

      unless allowed_authors.include?(author)

        errors.add :author_id, :invalid

      end

    end

    # ...

  end

  def allowed_authors(user = nil)

    users = assignable_users.select {|m| m.is_a?(User) && m.allowed_to?(:add_issues, project) }

    if new_record?

      [user || User.current] | users

    else

      [self.author] | users

    end

  end

end

module IssueHelper

  # ...

  def author_options_for_select(issue)

    principals_options_for_select(issue.allowed_authors, issue.author)

  end

end

 Note: I'm not sure why the current author_options_for_select helper method has such complicated logic for the persisted case. It appears to try to

allow the case where the author is a non-user principal (i.e. a group). This is the only case I can imagine where Principal.find(issue.author_id) is not

equivalent to issue.author. However, assigning a group as the author appears to not be allowed anyway and should be caught by a validation on the

Issue model. As such, I believe just using issue.author along with suitable validations on the model should be enough. Or am I missing something?

I'm also not sure why the current author_options_for_select helper requires a separate project argument. Shouldn't just using issue.project in there be

enough or is this required when changing the project of an existing issue? In my code above, I removed this argument as it uses the new

Issue#allowed_authors method anyway. Also, this got rid of the specific check for new_record? or persisted? in the helper as we initialize a new issue

with @issue.author ||= User.current anyway in all contexts where this helper is relevant.

Next, the change in app/views/issues/_attributes.html.erb seems to be one line too low. Currently, the ability to change the author is bound to the
ability to change the status. This should probably be moved outside that if check for the status.

(Note that I have not yet run my above code, it might be off by a bit, but should illustrate the basic idea. Please correct me if I got anything wrong

here.)

Finally, I think the separate set_author_journal helper on the Issue model and the corresponding idea that we create a new issue and with it its first

journal rather unexpected. I could imaging that we run into a lot of edge-cases here (e.g. with notifications as we would send two notifications for an

issue create, one for the issue, and one for the journal) or generally unexpected interaction with other code which dies not expect this.

Instead of this, I would propose that we introduce a new column on the issue table called creator_id which would be set to the initial user who created

the issue (same as we did for the author_id before this patch) and without the ability for users to change this field. We could then regard the author_id

as changeable with the normal journal handling, but could show both the creator and the author on issues#show (or possible just if they are different)

along with a new column for the IssueQuery.

This would make the author handling more predictable and would fit better into the way issues work today. What do you think?

#188 - 2022-11-17 02:58 - Go MAEDA

Holger, thank you for reviewing r21958. It has become clear that the code should be rewritten a lot, I would like to revert r21958 and r21959.

#189 - 2023-03-21 20:55 - Jean-Philippe Lang

Go MAEDA wrote in #note-188:

I would like to revert r21958 and r21959.

 +1

#190 - 2023-05-09 02:28 - Go MAEDA

- Target version changed from 5.1.0 to Candidate for next major release

#191 - 2023-11-02 07:28 - Mischa The Evil

- Related to Feature #9812: set or change author of a issue (via rest api) added
